// ---- Preprocessor -----------------------------------------------------------
#file "DeathRun Redux 2019"
#pragma semicolon 1
#pragma newdecls required

// ---- Includes ---------------------------------------------------------------
#include sourcemod
#include morecolors
#include sdkhooks
#include sdktools
#include tf2_stocks
#include tf2items

#undef REQUIRE_EXTENSIONS
#tryinclude steamtools
#tryinclude steamworks
#define REQUIRE_EXTENSIONS

#include tf2attributes
#include clientprefs

// ---- Defines ----------------------------------------------------------------
#define DR_VERSION "0.3.0"
#define PLAYERCOND_SPYCLOAK (1<<4)
#define MAXGENERIC 25	//Used as a limit in the config file

#define TEAM_SPECTATOR 1
#define TEAM_RED 2
#define TEAM_BLUE 3

#define DBD_UNDEF -1 //DBD = Don't Be Death
#define DBD_OFF 1
#define DBD_ON 2
#define DBD_THISMAP 3 // The cookie will never have this value
#define TIME_TO_ASK 30.0 //Delay between asking the client its preferences and it's connection/join.

#define CHAT_PREFIX	"{black}[DR]{default} "
#define AS_BOOL(%1)	( view_as<bool>( %1 ) )
#define AS_INT(%1)	( view_as<int>( %1 ) )

// ---- Variables --------------------------------------------------------------
bool g_bIsDRmap = false;
int g_iLastDeath = -1;
//new g_timesplayed_asdeath[MAXPLAYERS+1];
bool g_bOnPreparation = false;
int g_iDontBeDeath[ MAXPLAYERS + 1 ] = { DBD_UNDEF, ... };
int g_iQueuePriory[ MAXPLAYERS + 1 ];
bool g_bCanEmitSoundToDeath = true;

#if defined _steamtools_included || defined _SteamWorks_Included
bool g_bSteamTools = false;
bool g_bSteamWorks = false;
#endif

//GenerealConfig
bool g_bDisableFallDamage;
bool g_bDisableSelfDamage;
float g_flRunnerSpeed;
float g_flDeathSpeed;
new g_iRunnerOutline;
new g_iDeathOutline;

//Weapon-config
bool g_bMeleeOnly;
bool g_bMeleeRestricted;
bool g_bAllRestricted;
bool g_bRestrictAll;
StringMap g_hRestrictedWeps;
bool g_bUseDefault;
bool g_bUseAllClass;
StringMap g_hAllClassWeps;
bool g_bDisableSpyCloak;
bool g_bDisableDemoShield;
bool g_bDisableScoutDrink;
bool g_bDisableMedicGunHeal;
bool g_bDisableLunchHeal;

//Build-config
bool g_bDisableAllBuildings;
bool g_bDisableDispenser;
bool g_bDisableSentry;
bool g_bDisableTeleportEntr;
bool g_bDisableTeleportExit;

int g_iDefaultHPBlue = 125;


//Command-config
StringMap g_hCmdList;
// new Handle:g_CmdTeamToBlock;
// new Handle:g_CmdBlockOnlyOnPrep;

//Sound-config
StringMap g_hSndRoundStart;
StringMap g_hSndOnDeath;

float g_flOnKillDelay;
StringMap g_hSndOnKill;

StringMap g_hSndLastAlive;


// ---- Handles ----------------------------------------------------------------
Handle g_hCookieDR = null;

// ---- Server's CVars Management ----------------------------------------------
ConVar CVAR_UseQueue;
ConVar CVAR_UnbalanceLimit;
ConVar CVAR_AutoTeamBalance;
ConVar CVAR_FirstBlood;
ConVar CVAR_ScrambleAuto;
ConVar CVAR_AirDash;
ConVar CVAR_Push;

int g_iQueueDef = 0;
int g_iUnbalanceDef = 0;
int g_iAutoBalanceDef = 0;
int g_iFirstBloodDef = 0;
int g_iScrambleAutoDef = 0;
int g_iAirDashDef = 0;
int g_iPushDef = 0;

// ---- Plugin's Information ---------------------------------------------------
public Plugin myinfo = {
	name = "[TF2] Deathrun Redux 2019",
	author = "originally made by Classic, upgraded by Kapusta and Baltica_7, code improvements and error fix by MAGNAT2645",
	description	= "Deathrun plugin for TF2",
	version = DR_VERSION,
	url = "http://www.clangs.com.ar"
};

/* OnPluginStart()
**
** When the plugin is loaded.
** -------------------------------------------------------------------------- */
public void OnPluginStart() {
	LoadTranslations( "deathrun_redux.phrases.txt" );

	//Cvars
	CreateConVar( "dr_version", DR_VERSION, "DeathRun Redux Version", FCVAR_SPONLY | FCVAR_DONTRECORD | FCVAR_NOTIFY );

	//Creation of Tries
	g_hRestrictedWeps = new StringMap();
	g_hAllClassWeps = new StringMap();
	g_hCmdList = new StringMap();
	// g_CmdTeamToBlock = new StringMap();
	// g_CmdBlockOnlyOnPrep = new StringMap();
	g_hSndRoundStart = new StringMap();
	g_hSndOnDeath = new StringMap();
	g_hSndOnKill = new StringMap();
	g_hSndLastAlive = new StringMap();

	//Server's Cvars
	CVAR_UseQueue = FindConVar( "tf_arena_use_queue" );
	CVAR_UnbalanceLimit = FindConVar( "mp_teams_unbalance_limit" );
	CVAR_AutoTeamBalance = FindConVar( "mp_autoteambalance" );
	CVAR_FirstBlood = FindConVar( "tf_arena_first_blood" );
	CVAR_ScrambleAuto = FindConVar( "mp_scrambleteams_auto" );
	CVAR_AirDash = FindConVar( "tf_scout_air_dash_count" );
	CVAR_Push = FindConVar( "tf_avoidteammates_pushaway" );

	//Hooks
	HookEvent( "teamplay_round_start", OnPreparationStart, EventHookMode_PostNoCopy );
	HookEvent( "arena_round_start", OnRoundStart, EventHookMode_PostNoCopy );
	HookEvent( "post_inventory_application", OnPlayerInventory );
	HookEvent( "player_spawn", OnPlayerSpawn );
	HookEvent( "player_death", OnPlayerDeath, EventHookMode_Pre );
	HookEvent( "player_team", OnDeathChangeTeam );
	HookEvent( "teamplay_round_win", OnRoundEnd );

	//Preferences
	g_hCookieDR = RegClientCookie( "DR_dontBeDeath", "Does the client want to be the Death?", CookieAccess_Private );
	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( AreClientCookiesCached( i ) )
			OnClientCookiesCached( i );
	}

	RegConsoleCmd( "drmenu",  DeathMenu );
	RegConsoleCmd( "drqueue", DeathQueuePanel );
	RegConsoleCmd( "drplace", PlaceQueue );
	RegConsoleCmd( "drbedeath", BeDeathMenu );
	RegConsoleCmd( "drnext", CMD_NextDeath );
	//disable builds
	AddCommandListener( CommandListener_Build, "build" );
	//disable disguise
	//AddCommandListener(CommandListener_Disguise, "disguise");
}

/* OnPluginEnd()
**
** When the plugin is unloaded. Here we reset all the cvars to their normal value.
** -------------------------------------------------------------------------- */
public void OnPluginEnd() {
	ResetCvars();
}


#if defined _steamtools_included || defined _SteamWorks_Included
public void OnLibraryAdded(const char[] name) {
	if ( StrEqual( name, "SteamTools" ) )
		g_bSteamTools = true;
	else if ( StrEqual( name, "SteamWorks" ) )
		g_bSteamWorks = true;
}
public void OnLibraryRemoved(const char[] name) {
	if ( StrEqual( name, "SteamTools" ) )
		g_bSteamTools = false;
	else if ( StrEqual( name, "SteamWorks" ) )
		g_bSteamWorks = false;
}
#endif


/* OnMapStart()
**
** Here we reset every global variable, and we check if the current map is a deathrun map.
** If it is a dr map, we get the cvars def. values and the we set up our own values.
** -------------------------------------------------------------------------- */
public void OnMapStart() {
	g_iLastDeath = -1;
	//for(new i = 1; i <= MaxClients; i++)
			//g_timesplayed_asdeath[i]=-1;

	char sMapName[ 128 ];
	GetCurrentMap( sMapName, sizeof( sMapName ) );
	if ( strncmp( sMapName, "dr_", 3, false ) == 0 || strncmp( sMapName, "deathrun_", 9, false ) == 0 ||
		strncmp( sMapName, "vsh_dr_", 6, false ) == 0 || strncmp( sMapName, "vsh_deathrun_", 6, false ) == 0)
	{
		LogMessage( "Deathrun map detected. Enabling Deathrun Gamemode." );
		g_bIsDRmap = true;

#if defined _steamtools_included || defined _SteamWorks_Included
		if ( g_bSteamTools )
			Steam_SetGameDescription( "DeathRun Redux 2019" );
		else if ( g_bSteamWorks )
			SteamWorks_SetGameDescription( "DeathRun Redux 2019" );
#endif

		AddServerTag( "deathrun" );

		for ( int i = 1; i <= MaxClients; i++ ) {
			if ( AreClientCookiesCached( i ) )
				OnClientCookiesCached( i );
		}

		LoadConfigs();
		PrecacheFiles();
		//ProcessListeners();
	} else {
		LogMessage( "Current map is not a deathrun map. Disabling Deathrun Gamemode." );
		g_bIsDRmap = false;

#if defined _steamtools_included || defined _SteamWorks_Included
		if ( g_bSteamTools )
			Steam_SetGameDescription( "Team Fortress" );
		else if ( g_bSteamWorks )
			SteamWorks_SetGameDescription( "Team Fortress" );
#endif

		RemoveServerTag( "deathrun" );
	}
}

/* OnMapEnd()
**
** Here we reset the server's cvars to their default values.
** -------------------------------------------------------------------------- */
public void OnMapEnd() {
	ResetCvars();
	for ( int i = 1; i <= MaxClients; i++ )
		g_iDontBeDeath[ i ] = DBD_UNDEF;
}

/* LoadConfigs()
**
** Here we parse the data/deathrun/deathrun.cfg
** -------------------------------------------------------------------------- */
void LoadConfigs() {
	//--DEFAULT VALUES--
	//GenerealConfig
	g_bDisableFallDamage = false;
	g_bDisableSelfDamage = false;
	g_flRunnerSpeed = 300.0;
	g_flDeathSpeed = 400.0;
	g_iRunnerOutline = 0;
	g_iDeathOutline = -1;

	//Weapon-config
	g_bMeleeOnly = true;
	g_bMeleeRestricted = true;
	g_bAllRestricted = true;
	g_bRestrictAll = true;
	g_hRestrictedWeps.Clear();
	g_bUseDefault = true;
	g_bUseAllClass = false;
	g_bDisableSpyCloak = false;
	g_bDisableDemoShield = false;
	g_bDisableScoutDrink = false;
	g_bDisableMedicGunHeal = false;
	g_bDisableLunchHeal = false;
	g_hAllClassWeps.Clear();

	//build config
	g_bDisableAllBuildings = false;
	g_bDisableDispenser = false;
	g_bDisableSentry = false;
	g_bDisableTeleportEntr = false;
	g_bDisableTeleportExit = false;

	//Command-config
	g_hCmdList.Clear();
	//ClearTrie(g_CmdTeamToBlock);
	// ClearTrie(g_CmdBlockOnlyOnPrep);

	//Sound-config
	g_hSndRoundStart.Clear();
	g_hSndOnDeath.Clear();
	g_flOnKillDelay = 5.0;
	g_hSndOnKill.Clear();
	g_hSndLastAlive.Clear();

	char sMainFile[ PLATFORM_MAX_PATH ];
	BuildPath( Path_SM, sMainFile, sizeof( sMainFile ), "data/deathrun/deathrun.cfg" );

	if ( !FileExists( sMainFile ) ) {
		SetFailState( "Configuration file %s not found!", sMainFile );
		return;
	}

	KeyValues hDR = new KeyValues( "deathrun" );
	if ( !hDR.ImportFromFile( sMainFile ) ) {
		SetFailState( "Improper structure for configuration file %s!", sMainFile );
		return;
	}

	if ( hDR.JumpToKey( "default" ) ) {
		g_bDisableFallDamage = AS_BOOL( hDR.GetNum( "DisableFallDamage", AS_INT( g_bDisableFallDamage ) ) );
		g_bDisableSelfDamage = AS_BOOL( hDR.GetNum( "DisableSelfDamage", AS_INT( g_bDisableSelfDamage ) ) );

		if ( hDR.JumpToKey( "speed" ) ) {
			g_flRunnerSpeed = hDR.GetFloat( "runners", g_flRunnerSpeed );
			g_flDeathSpeed = hDR.GetFloat( "death", g_flDeathSpeed );
			hDR.GoBack();
		}

		if ( hDR.JumpToKey( "outline" ) ) {
			g_iRunnerOutline = hDR.GetNum( "runners", g_iRunnerOutline );
			g_iDeathOutline = hDR.GetNum( "death", g_iDeathOutline );
			hDR.GoBack();
		}

		hDR.GoBack();
	}


	hDR.Rewind();
	if ( hDR.JumpToKey( "weapons" ) ) {
		g_bMeleeOnly = AS_BOOL( hDR.GetNum( "MeleeOnly", AS_INT( g_bMeleeOnly ) ) );
		g_bDisableSpyCloak = AS_BOOL( hDR.GetNum( "DisableSpyCloakAndDisguise", AS_INT( g_bDisableSpyCloak ) ) );
		g_bDisableDemoShield = AS_BOOL( hDR.GetNum( "DisableDemoShield", AS_INT( g_bDisableDemoShield ) ) );
		g_bDisableScoutDrink = AS_BOOL( hDR.GetNum( "DisableScoutDrink", AS_INT( g_bDisableScoutDrink ) ) );
		g_bDisableMedicGunHeal = AS_BOOL( hDR.GetNum( "DisableMedicGunHeal", AS_INT( g_bDisableMedicGunHeal ) ) );
		g_bDisableLunchHeal = AS_BOOL( hDR.GetNum( "DisableLunchBoxHeal", AS_INT( g_bDisableLunchHeal ) ) );
		g_bMeleeRestricted = AS_BOOL( hDR.GetNum( "RestrictedMelee", AS_INT( g_bMeleeRestricted ) ) );
		g_bAllRestricted = AS_BOOL( hDR.GetNum( "RestrictedAll", AS_INT( g_bAllRestricted ) ) );

		if ( g_bMeleeRestricted ) {
			hDR.JumpToKey( "AllRestriction" );
			g_bRestrictAll = AS_BOOL( hDR.GetNum( "RestrictAll", AS_INT( g_bRestrictAll ) ) );
			if ( !g_bRestrictAll ) {
				hDR.JumpToKey( "RestrictedWeapons" );
				char sKey[ 4 ];
				int auxInt;
				for ( int i = 1; i < MAXGENERIC; i++ ) {
					IntToString( i, sKey, sizeof( sKey ) );
					auxInt = hDR.GetNum( sKey, -1 );
					if ( auxInt == -1 )
						break;

					g_hRestrictedWeps.SetValue( sKey, auxInt );
				}

				hDR.GoBack();
			}

			g_bUseDefault = AS_BOOL( hDR.GetNum( "UseDefault", AS_INT( g_bUseDefault ) ) );
			g_bUseAllClass = AS_BOOL( hDR.GetNum( "UseAllClass", AS_INT( g_bUseAllClass ) ) );
			if ( g_bUseAllClass ) {
				hDR.JumpToKey( "AllClassWeapons" );
				char sKey[ 4 ];
				int auxInt;
				for ( int i = 1; i < MAXGENERIC; i++ ) {
					IntToString( i, sKey, sizeof( sKey ) );
					auxInt = hDR.GetNum( sKey, -1 );
					if ( auxInt == -1 )
						break;

					g_hAllClassWeps.SetValue( sKey, auxInt );
				}
				hDR.GoBack();
			}

			hDR.GoBack();
		}

	}

	/*KvRewind(hDR);
	KvJumpToKey(hDR,"blockcommands");
	do
	{
		decl String:SectionName[128], String:CommandName[128];
		new onprep, bool:onrunners, bool:ondeath, teamToBlock;
		KvGotoFirstSubKey(hDR);
		KvGetSectionName(hDR, SectionName, sizeof(SectionName));

		KvGetString(hDR, "command", CommandName, sizeof(CommandName));
		onprep = KvGetNum(hDR, "OnlyOnPreparation", 0);
		onrunners = !!KvGetNum(hDR,"runners",1);
		ondeath = !!KvGetNum(hDR,"death",1);

		teamToBlock = 0;
		if((onrunners && ondeath))
			teamToBlock = 1;
		else if(onrunners && !ondeath)
			teamToBlock = TEAM_RED;
		else if(!onrunners && ondeath)
			teamToBlock = TEAM_BLUE;

		if(!StrEqual(CommandName, "") || teamToBlock == 0)
		{
			SetTrieString(g_hCmdList,SectionName,CommandName);
			SetTrieValue(g_CmdBlockOnlyOnPrep,CommandName,onprep);
			SetTrieValue(g_CmdTeamToBlock,CommandName,teamToBlock);
		}
	}
	*/
	//while(KvGotoNextKey(hDR));

	hDR.Rewind();
	if ( hDR.JumpToKey( "BlockBuilds" ) ) {
		g_bDisableAllBuildings = AS_BOOL( hDR.GetNum( "DisableAllBuilds", AS_INT( g_bDisableAllBuildings ) ) );
		g_bDisableDispenser = AS_BOOL( hDR.GetNum( "DisableDispenser", AS_INT( g_bDisableDispenser ) ) );
		g_bDisableSentry = AS_BOOL( hDR.GetNum( "DisableSentry", AS_INT( g_bDisableSentry ) ) );
		g_bDisableTeleportEntr = AS_BOOL( hDR.GetNum( "DisableTpEntr", AS_INT( g_bDisableTeleportEntr ) ) );
		g_bDisableTeleportExit = AS_BOOL( hDR.GetNum( "DisableTpExit", AS_INT( g_bDisableTeleportExit ) ) );
		hDR.GoBack();
	}


	hDR.Rewind();
	if ( hDR.JumpToKey( "sounds" ) ) {
		char sKey[ 4 ], sSndFile[ PLATFORM_MAX_PATH ];
		if ( hDR.JumpToKey( "RoundStart" ) ) {
			for ( int i = 1; i < MAXGENERIC; i++ ) {
				IntToString( i, sKey, sizeof( sKey ) );
				hDR.GetString( sKey, sSndFile, sizeof( sSndFile ) );
				if ( !sSndFile[ 0 ] )
					break;

				g_hSndRoundStart.SetString( sKey, sSndFile );
			}
			hDR.GoBack();
		}

		if ( hDR.JumpToKey( "OnDeath" ) ) {
			for ( int i = 1; i < MAXGENERIC; i++ ) {
				IntToString( i, sKey, sizeof( sKey ) );
				hDR.GetString( sKey, sSndFile, sizeof( sSndFile ) );
				if ( !sSndFile[ 0 ] )
					break;

				g_hSndOnDeath.SetString( sKey, sSndFile );
			}
			hDR.GoBack();
		}

		if ( hDR.JumpToKey( "OnKill" ) ) {
			g_flOnKillDelay = hDR.GetFloat( "delay", g_flOnKillDelay );

			for ( int i = 1; i < MAXGENERIC; i++ ) {
				IntToString( i, sKey, sizeof( sKey ) );
				hDR.GetString( sKey, sSndFile, sizeof( sSndFile ) );
				if ( !sSndFile[ 0 ] )
					break;

				g_hSndOnKill.SetString( sKey, sSndFile );
			}

			hDR.GoBack();
		}

		if ( hDR.JumpToKey( "LastAlive" ) ) {
			for ( int i = 1; i < MAXGENERIC; i++ ) {
				IntToString( i, sKey, sizeof( sKey ) );
				hDR.GetString( sKey, sSndFile, sizeof( sSndFile ) );
				if ( !sSndFile[ 0 ] )
					break;

				g_hSndLastAlive.SetString( sKey, sSndFile );
			}
			hDR.GoBack();
		}

		hDR.GoBack();
	}

	hDR.Close();

	char sMapFile[ PLATFORM_MAX_PATH ], sMapName[ 128 ];
	GetCurrentMap( sMapName, sizeof( sMapName ) );
	BuildPath( Path_SM, sMapFile, sizeof( sMapFile ), "data/deathrun/maps/%s.cfg", sMapName );

	if ( FileExists( sMapFile ) ) {
		hDR = new KeyValues( "drmap" );
		if ( !hDR.ImportFromFile( sMapName ) ) {
			SetFailState( "Improper structure for configuration file %s!", sMapFile );
			return;
		}

		g_bDisableFallDamage = AS_BOOL( hDR.GetNum( "DisableFallDamage", AS_INT( g_bDisableFallDamage ) ) );
		g_bDisableSelfDamage = AS_BOOL( hDR.GetNum( "DisableSelfDamage", AS_INT( g_bDisableSelfDamage ) ) );

		if ( hDR.JumpToKey( "speed" ) ) {
			g_flRunnerSpeed = hDR.GetFloat( "runners", g_flRunnerSpeed );
			g_flDeathSpeed = hDR.GetFloat( "death", g_flDeathSpeed );
			hDR.GoBack();
		}

		if ( hDR.JumpToKey( "outline" ) ) {
			g_iRunnerOutline = hDR.GetNum( "runners", g_iRunnerOutline );
			g_iDeathOutline = hDR.GetNum( "death", g_iDeathOutline );
		}

		hDR.Close();
	}
}


/* PrecacheFiles()
**
** We precache and add to the download table every sound file found on the config file.
** -------------------------------------------------------------------------- */
void PrecacheFiles() {
	PrecacheSoundFromTrie( g_hSndRoundStart );
	PrecacheSoundFromTrie( g_hSndOnDeath );
	PrecacheSoundFromTrie( g_hSndOnKill );
	PrecacheSoundFromTrie( g_hSndLastAlive);
}

/* PrecacheFiles()
**
** We precache and add to the download table, reading every value of a Trie.
** -------------------------------------------------------------------------- */
void PrecacheSoundFromTrie(StringMap sndTrie) {
	int iTrieSize = sndTrie.Size;
	char sSoundString[ PLATFORM_MAX_PATH ], sKey[ 4 ];

	for ( int i = 1; i <= iTrieSize; i++ ) {
		IntToString( i, sKey, sizeof( sKey ) );
		if ( sndTrie.GetString( sKey, sSoundString, sizeof( sSoundString ) ) && PrecacheSound( sSoundString ) ) {
			Format( sSoundString, sizeof( sSoundString ), "sound/%s", sSoundString );
			AddFileToDownloadsTable( sSoundString );
		}
	}
}


/* ProcessListeners()
**
** Here we add the listeners to block the commands defined on the config file.
** --------------------------------------------------------------------------
ProcessListeners(bool:removeListerners=false)
{
	new trieSize = GetTrieSize(g_hCmdList);
	decl String:command[PLATFORM_MAX_PATH],String:key[4];
	for(new i = 1; i <= trieSize; i++)
	{
		IntToString(i,key,sizeof(key));
		if(GetTrieString(g_hCmdList,key,command, sizeof(command)))
		{
			if(StrEqual(command, ""))
					break;

			if(removeListerners)
				RemoveCommandListener(Command_Block,command);
			else
				AddCommandListener(Command_Block,command);


			GetTrieValue(g_CmdBlockOnlyOnPrep,key,PreparationOnly);
			if(removeListerners)
			{
				if(PreparationOnly == 1)
					RemoveCommandListener(Command_Block_PreparationOnly,command);
				else
					RemoveCommandListener(Command_Block,command);
			}
			else
			{
				if(PreparationOnly == 1)
					AddCommandListener(Command_Block_PreparationOnly,command);
				else
					AddCommandListener(Command_Block,command);
			}


		}
	}
}
*/

/* OnClientPutInServer()
**
** We set on zero the time played as death when the client enters the server.
** -------------------------------------------------------------------------- */
public void OnClientPutInServer(int client) {
	//g_timesplayed_asdeath[client] = 0;
	SDKHook( client, SDKHook_OnTakeDamage, OnTakeDamage ); //for disable self damage
	g_iQueuePriory[ client ]++;
}

/* OnClientDisconnect()
**
** We set as minus one the time played as death when the client leaves.
** When searching for a Death we ignore every client with the -1 value.
** We also set as undef the preference value
** -------------------------------------------------------------------------- */
public void OnClientDisconnect(int client) {
	//g_timesplayed_asdeath[client] =-1;
	if ( g_iDontBeDeath[ client ] == DBD_THISMAP )
		g_iDontBeDeath[ client ] = DBD_UNDEF;

	if ( g_bOnPreparation && client == g_iLastDeath )
		BalanceTeams();
}

/* OnClientCookiesCached()
**
** We look if the client have a saved value
** -------------------------------------------------------------------------- */
public void OnClientCookiesCached(int client) {
	char sValue[ 8 ];
	GetClientCookie( client, g_hCookieDR, sValue, sizeof( sValue ) );
	int iValue = StringToInt( sValue );

	if ( iValue < DBD_OFF ) //If cookie is not valid we ask for a preference.
		CreateTimer( TIME_TO_ASK, TMR_AskMenu, GetClientUserId( client ) );
	else //client has a valid cookie
		g_iDontBeDeath[ client ] = iValue;
}

public Action TMR_AskMenu(Handle timer, any data) {
	DeathMenu( GetClientOfUserId( data ), 0 );
}

public Action DeathMenu(int client, int args) {
	if ( !( client && IsClientInGame( client ) ) )
		return Plugin_Handled;

	Menu hMenu = new Menu( DeathMenuHandler );
	hMenu.SetTitle( "%T", "DR_DEATH_MENU_TITLE", client );

	char sItem[ 64 ];
	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DEATH_MENU_QUEUE", client );
	hMenu.AddItem( "", sItem );

	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DEATH_MENU_MY_PLACE", client );
	hMenu.AddItem( "", sItem );

	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DEATH_MENU_BD", client );
	hMenu.AddItem( "", sItem );

	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DEATH_MENU_NEXT_DEATH", client );
	hMenu.AddItem( "", sItem );

	hMenu.ExitButton = true;
	hMenu.Display( client, 30 );

	return Plugin_Handled;
}
public int DeathMenuHandler(Menu menu, MenuAction action, int param1, int param2) {
	if ( action == MenuAction_Select ) {
		switch ( param2 ) {
			case 0:	DeathQueuePanel( param1, 0 );
			case 1:	PlaceQueue( param1, 0 );
			case 2:	BeDeathMenu( param1, 0 );
			case 3:	CMD_NextDeath( param1, 0 );
		}
	}
	else if ( action == MenuAction_End )
		menu.Close();
}

public Action DeathQueuePanel(int client, int args) {
	if ( !( client && IsClientInGame( client ) ) )
		return Plugin_Handled;

	Menu hMenu = new Menu( DeathQMenuHandler );
	hMenu.SetTitle( "%T", "DR_DEATH_MENU_QUEUE", client );

	int iQueue[ MAXPLAYERS + 1 ][ MAXPLAYERS + 1 ];
	int iPoints = 0, iPos = 0, iKol = 0;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !( IsClientInGame( i ) && GetClientTeam( i ) == TEAM_RED ) )
			continue;

		iQueue[ i ][ 2 ] = g_iQueuePriory[ i ];
		iQueue[ i ][ 1 ] = i;
		iKol++;
	}

	for ( int i = 1; i <= MAXPLAYERS; i++ ) {
		for ( int j = 1; j <= MAXPLAYERS; j++ ) {
			if ( iQueue[ i ][ 2 ] >= iQueue[ j ][ 2 ] ) {
				iPoints = iQueue[ i ][ 2 ];
				iPos = iQueue[ i ][ 1 ];
				iQueue[ i ][ 2 ] = iQueue[ j ][ 2 ];
				iQueue[ i ][ 1 ] = iQueue[ j ][ 1 ];
				iQueue[ j ][ 2 ] = iPoints;
				iQueue[ j ][ 1 ] = iPos;
			}
		}
	}

	char sName[ MAX_NAME_LENGTH ], sItem[ 64 ];

	//AddMenuItem(menuQ, "0", "current death:");
	int iDeath = GetLastPlayer( TEAM_BLUE );
	if ( iDeath != -1 ) {
		GetClientName( iDeath, sName, sizeof( sName ) );
		FormatEx( sItem, sizeof( sItem ), "%s \n ---------------", sName );
	}
	else
		FormatEx( sItem, sizeof( sItem ), "%T \n ---------------", "DR_QUEUE_MENU_NOT_SELECTED", client );
	hMenu.AddItem( "", sItem, ITEMDRAW_DISABLED );

	//AddMenuItem(menuQ, "2", "-----------");
	int iCount = GetClientCount( true );
	for ( int i = 1; i <= iKol; i++ ) {
		if ( !IsClientInGame( iQueue[ i ][ 1 ] ) || ( iCount > 4 && g_iDontBeDeath[ iQueue[ i ][ 1 ] ] >= DBD_ON ) )
			continue;

		GetClientName( iQueue[ i ][ 1 ], sName, sizeof( sName ) );
		hMenu.AddItem( "", sName, ITEMDRAW_DISABLED );
	}

		/*for (new j = 1; j<=MAXPLAYERS; j++) {
			if (Max<=dqueue[j][2]&&IsClientInGame(dqueue[j][1])&&IsClientConnected(dqueue[j][1])) {
				Max = dqueue[j][2];
				pos = dqueue[j][1];
			}
		}
				dqueue[i][2] = 0;
				char name[32];
				char num[32];
				//char points[32];
				GetClientName(pos, name,sizeof(name));
				IntToString(i,num,sizeof(num));
				if (Max > 0) {
				AddMenuItem(menuQ, num, name);
	}
	}
	*/

	hMenu.ExitBackButton = true;
	hMenu.ExitButton = true;
	hMenu.Display( client, 30 );

	return Plugin_Handled;
}
public int DeathQMenuHandler(Menu menu, MenuAction action, int param1, int param2) {
	if ( action == MenuAction_Cancel ) {
		if ( param2 == MenuCancel_ExitBack )
			DeathMenu( param1, 0 );
	}
	else if ( action == MenuAction_End )
		menu.Close();
}

public Action PlaceQueue(int client, int args) {
	if ( !( client && IsClientInGame( client ) ) )
		return Plugin_Handled;

	Menu hMenu = new Menu( DeathPQMenuHandler );
	hMenu.SetTitle( "%T", "DR_DEATH_MENU_MY_PLACE", client );

	int iQueue[ MAXPLAYERS + 1 ][ MAXPLAYERS + 1 ];
	int iPoints = 0, iPos = 0;

	bool bCount = GetClientCount( true ) > 4;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !( IsClientInGame( i ) && i != GetLastPlayer( TEAM_BLUE ) && GetClientTeam( i ) != TEAM_SPECTATOR ) ) {
			iQueue[ i ][ 2 ] = 0;
			continue;
		}

		if ( bCount && g_iDontBeDeath[ i ] >= DBD_ON )
			continue;

		iQueue[ i ][ 2 ] = g_iQueuePriory[ i ];
		iQueue[ i ][ 1 ] = i;
	}

	for ( int i = 1; i <= MAXPLAYERS; i++ ) {
		for ( int j = 1; j <= MAXPLAYERS; j++ ) {
			if ( iQueue[ i ][ 2 ] >= iQueue[ j ][ 2 ] && iQueue[ i ][ 2 ] > 0 && iQueue[ j ][ 2 ] > 0 ) {
				iPoints = iQueue[ i ][ 2 ];
				iPos = iQueue[ i ][ 1 ];
				iQueue[ i ][ 2 ] = iQueue[ j ][ 2 ];
				iQueue[ i ][ 1 ] = iQueue[ j ][ 1 ];
				iQueue[ j ][ 2 ] = iPoints;
				iQueue[ j ][ 1 ] = iPos;
			}
		}
	}

	char sItem[ 128 ];
	if ( client == GetLastPlayer( TEAM_BLUE ) ) {
		FormatEx( sItem, sizeof( sItem ), "%T", "DR_PLACE_MENU_DEATH_NOW", client );
		hMenu.AddItem( "", sItem, ITEMDRAW_DISABLED );
	} else if ( GetClientTeam( client ) == TEAM_SPECTATOR ) {
		FormatEx( sItem, sizeof( sItem ), "%T", "DR_PLACE_MENU_SPECTATOR", client );
		hMenu.AddItem( "", sItem, ITEMDRAW_DISABLED );
	} else {
		if ( bCount && g_iDontBeDeath[client] >= DBD_ON ) {
			FormatEx( sItem, sizeof( sItem ), "%T", "DR_PLACE_MENU_DBD", client );
			hMenu.AddItem( "", sItem, ITEMDRAW_DISABLED );
		} else {
			for ( int i = 1; i <= MAXPLAYERS; i++ ) {
				if ( iQueue[ i ][ 1 ] == client ) {
					FormatEx( sItem, sizeof( sItem ), "%T", "DR_PLACE_MENU_NUM", client, i );
					hMenu.AddItem( "", sItem, ITEMDRAW_DISABLED );
				}
			}
		}
	}

	hMenu.ExitBackButton = true;
	hMenu.ExitButton = true;
	hMenu.Display( client, 30 );

	return Plugin_Handled;
}
public int DeathPQMenuHandler(Menu menu, MenuAction action, int param1, int param2) {
	if ( action == MenuAction_Cancel ) {
		if ( param2 == MenuCancel_ExitBack )
			DeathMenu( param1, 0 );
	}
	else if ( action == MenuAction_End )
		menu.Close();
}

public Action CMD_NextDeath(int client, int args) {
	if ( !( client && IsClientInGame( client ) ) )
		return Plugin_Handled;

	Menu hMenu = new Menu( NextDeathHandler );
	hMenu.SetTitle( "%T", "DR_DEATH_MENU_NEXT_DEATH", client );

	int iMax = g_iQueuePriory[ 1 ], iDeath = 1;
	for ( int i = 1; i <= MAXPLAYERS; i++ ) {
		if ( iMax > g_iQueuePriory[ i ] )
			continue;

		iMax = g_iQueuePriory[ i ];
		iDeath = i;
	}

	char sName[ 64 ];
	if ( IsInBounds( iDeath, 1, MaxClients ) && IsClientInGame( iDeath ) )
		GetClientName( iDeath, sName, sizeof( sName ) );
	else
		FormatEx( sName, sizeof( sName ), "%T", "DR_INVALID_DEATH", client );

	hMenu.AddItem( "", sName, ITEMDRAW_DISABLED );
	hMenu.ExitBackButton = true;
	hMenu.ExitButton = true;
	hMenu.Display( client, 30 );

	return Plugin_Handled;
}

public int NextDeathHandler(Menu menu, MenuAction action, int param1, int param2) {
	if ( action == MenuAction_Cancel ) {
		if ( param2 == MenuCancel_ExitBack )
			DeathMenu( param1, 0 );
	}
	else if ( action == MenuAction_End )
		menu.Close();
}

public Action BeDeathMenu(int client, int args) {
	if ( !( client && IsClientInGame( client ) ) )
		return Plugin_Handled;

	Menu hMenu = new Menu( BeDeathMenuHandler );
	hMenu.SetTitle( "%T", "DR_DEATH_MENU_BD", client );

	char sItem[ 64 ];
	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DBD_MENU_ALLOW", client );
	hMenu.AddItem( "", sItem );

	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DBD_MENU_DISALLOW", client );
	hMenu.AddItem( "", sItem );

	FormatEx( sItem, sizeof( sItem ), "%T", "DR_DBD_MENU_THIS_MAP", client );
	hMenu.AddItem( "", sItem );

	hMenu.ExitBackButton = true;
	hMenu.ExitButton = true;
	hMenu.Display( client, 30 );

	return Plugin_Handled;
}

public int BeDeathMenuHandler(Menu menu, MenuAction action, int param1, int param2) {
	switch ( action ) {
		case MenuAction_Select: {
			switch ( param2 ) {
				case 0: {
					g_iDontBeDeath[ param1 ] = DBD_OFF;
					CPrintToChat( param1, CHAT_PREFIX ... "%t", "DR_DBD_MENU_ALLOW_NOTIFY" );
				}
				case 1: {
					g_iDontBeDeath[ param1 ] = DBD_ON;
					CPrintToChat( param1, CHAT_PREFIX ... "%t", "DR_DBD_MENU_DISALLOW_NOTIFY" );
				}
				case 2: {
					g_iDontBeDeath[ param1 ] = DBD_THISMAP;
					CPrintToChat( param1, CHAT_PREFIX ... "%t", "DR_DBD_MENU_THIS_MAP_NOTIFY" );
				}
			}

			if ( param2 != 2 ) {
				char sPref[ 2 ];
				IntToString( g_iDontBeDeath[ param1 ], sPref, sizeof( sPref ) );
				SetClientCookie( param1, g_hCookieDR, sPref );
			}

			DeathMenu( param1, 0 );
		}
		case MenuAction_Cancel: {
			if ( param2 == MenuCancel_ExitBack )
				DeathMenu( param1, 0 );
		}
		case MenuAction_End:	menu.Close();
	}
}

/* OnPreparationStart()
**
** We setup the cvars again, balance the teams and we freeze the players.
** -------------------------------------------------------------------------- */
public void OnPreparationStart(Event event, const char[] name, bool dontBroadcast) {
	if ( !g_bIsDRmap )
		return;

	g_bOnPreparation = true;

	//We force the cvars values needed every round (to override if any cvar was changed).
	SetupCvars();
	BalanceTeams(); //We move the players to the corresponding team.

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !( IsClientInGame( i ) && IsPlayerAlive( i ) ) )
			continue;

		g_iQueuePriory[ i ] += 10;
		SetEntityMoveType( i, MOVETYPE_NONE ); //Players shouldn't move until the round starts
	}

	EmitRandomSound( g_hSndRoundStart );

	if ( !g_bMeleeOnly ) {
		int iCurrentDeath = GetLastPlayer( TEAM_BLUE );
		TF2Attrib_RemoveByName( iCurrentDeath, "max health additive bonus" );
		SetEntityHealth( iCurrentDeath, 125 );
		TF2_RegeneratePlayer( iCurrentDeath );
	}
}

/* OnRoundStart()
**
** We unfreeze every player.
** -------------------------------------------------------------------------- */
public void OnRoundStart(Event event, const String:name[], bool:dontBroadcast) {
	if ( !g_bIsDRmap )
		return;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !( IsClientInGame( i ) && IsPlayerAlive( i ) ) )
			continue;

		SetEntityMoveType( i, MOVETYPE_WALK );
		if ( ( GetClientTeam( i ) == TEAM_RED && !g_iRunnerOutline ) || ( GetClientTeam(i) == TEAM_BLUE && !g_iDeathOutline ) )
			SetEntProp( i, Prop_Send, "m_bGlowEnabled", true );
	}

	g_bOnPreparation = false;

	// Idk why this code is here, this event doesn't have "userid"
	/*if(!g_bMeleeOnly){
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		new aliveRunners = GetAlivePlayersCount(TEAM_RED,client);
		new currentDeath = GetLastPlayer(TEAM_BLUE);
		g_iDefaultHPBlue = GetClientHealth(currentDeath);
		new HealthBlue = GetClientHealth(currentDeath);
		if(aliveRunners>=30){
			HealthBlue = 2000-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if((aliveRunners>=20)&&(aliveRunners<30)){
			HealthBlue = 1700-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if((aliveRunners>=15)&&(aliveRunners<20)){
			HealthBlue = 1500-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if((aliveRunners>=10)&&(aliveRunners<15)){
			HealthBlue = 1000-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if((aliveRunners>=5)&&(aliveRunners<10)){
			HealthBlue = 700-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if((aliveRunners>=2)&&(aliveRunners<5)){
			HealthBlue = 500-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
		if(aliveRunners == 1){
			HealthBlue = 200-HealthBlue;
			TF2Attrib_SetByName(currentDeath, "max health additive bonus", float(HealthBlue));
			TF2_RegeneratePlayer(currentDeath);
		}
	}*/
}

/* TF2Items_OnGiveNamedItem_Post()
**
** Here we disable all builds
** -------------------------------------------------------------------------- */
public int TF2Items_OnGiveNamedItem_Post(int client, char[] classname, int index, int level, int quality, int ent) {
	if ( g_bIsDRmap && g_bDisableAllBuildings ) {
		if ( StrEqual( classname, "tf_weapon_builder", false ) )
			CreateTimer( 0.1, TMR_RemoveWep, EntIndexToEntRef( ent ) );
	}
}

/* TMR_RemoveWep()
**
** We kill builder
** -------------------------------------------------------------------------- */
public Action TMR_RemoveWep(Handle timer, any data) {
	int iEnt = EntRefToEntIndex( data );
	if ( iEnt > MaxClients && IsValidEntity( iEnt ) )
		AcceptEntityInput( iEnt, "Kill" );
}



/* OnPlayerInventory()
**
** Here we strip players weapons (if we have to).
** Also we give special melee weapons (again, if we have to).
** -------------------------------------------------------------------------- */
public void OnPlayerInventory(Event event, const char[] name, bool dontBroadcast) {
	if ( !g_bIsDRmap )
		return;

	int iClient = GetClientOfUserId( event.GetInt( "userid" ) );
	if ( !iClient )
		return;

	TFItem hItem = new TFItem( FORCE_GENERATION | OVERRIDE_CLASSNAME | OVERRIDE_ITEM_DEF | OVERRIDE_ITEM_LEVEL |
		OVERRIDE_ITEM_QUALITY | OVERRIDE_ATTRIBUTES );
	hItem.Level = 69;
	hItem.Quality = 6;
	hItem.SetAttribute( 0, 150, 1.0 ); //Turn to gold on kill
	hItem.NumAttributes = 1;

	TFClassType iClass = TF2_GetPlayerClass( iClient );

	if ( g_bMeleeOnly ) {
		TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Primary );
		TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Secondary );
		TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Grenade );
		TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Building );
		TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_PDA );

		if ( g_bMeleeRestricted ) {
			bool bReplaceWep = g_bRestrictAll;

			if ( !g_bRestrictAll ) {
				int iWepEnt = GetPlayerWeaponSlot( iClient, TFWeaponSlot_Melee );
				if ( iWepEnt != -1 ) {
					int iWepIndex = GetEntProp( iWepEnt, Prop_Send, "m_iItemDefinitionIndex" ),
					iSize = g_hRestrictedWeps.Size, iAuxIndex;
					char sKey[ 4 ];
					for ( int i = 1; i <= iSize; i++ ) {
						IntToString( i, sKey, sizeof( sKey ) );
						if ( g_hRestrictedWeps.GetValue( sKey, iAuxIndex ) && iWepIndex == iAuxIndex )
							bReplaceWep = true;
					}
				}
			}

			if ( bReplaceWep ) {
				TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Melee );

				int iWeaponToUse = -1;

				if ( g_bUseAllClass ) {
					int iAcwSize = g_hAllClassWeps.Size, iRndNum;
					if ( g_bUseDefault )
						iRndNum = GetRandomInt( 1, iAcwSize + 1 );
					else
						iRndNum = GetRandomInt( 1, iAcwSize );

					if ( iRndNum <= iAcwSize ) {
						char sKey[ 4 ];
						IntToString( iRndNum, sKey, sizeof( sKey ) );
						g_hAllClassWeps.GetValue( sKey, iWeaponToUse );
					}
				}

				//Here we give a melee to every class
				switch ( iClass ) {
					case TFClass_Scout: {
						hItem.SetClassname( "tf_weapon_bat" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 190;
					}
					case TFClass_Sniper: {
						hItem.SetClassname( "tf_weapon_club" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 193;
					}
					case TFClass_Soldier: {
						hItem.SetClassname( "tf_weapon_shovel" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 196;
					}
					case TFClass_DemoMan: {
						hItem.SetClassname( "tf_weapon_bottle" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 191;
					}
					case TFClass_Medic: {
						hItem.SetClassname( "tf_weapon_bonesaw" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 198;
					}
					case TFClass_Heavy: {
						hItem.SetClassname( "tf_weapon_fists" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 195;
					}
					case TFClass_Pyro: {
						hItem.SetClassname( "tf_weapon_fireaxe" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 192;
					}
					case TFClass_Spy: {
						hItem.SetClassname( "tf_weapon_knife" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 194;
					}
					case TFClass_Engineer: {
						hItem.SetClassname( "tf_weapon_wrench" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 197;
					}
				}

				hItem.ItemIndex = iWeaponToUse;
				EquipPlayerWeapon( iClient, hItem.GiveNamedItem( iClient ) );
			}
		}

		TF2_SwitchToSlot( iClient, TFWeaponSlot_Melee );
	} else {
		if ( g_bAllRestricted ) {
			bool bReplaceWep = g_bRestrictAll, bReplaceWep2 = false, bReplaceWep3 = false;
			bool bWep3 = false;

			if ( !g_bRestrictAll ) {
				int iWepEnt = GetPlayerWeaponSlot( iClient, TFWeaponSlot_Melee ),
				iWepEnt2 = GetPlayerWeaponSlot( iClient, TFWeaponSlot_Secondary );
				if ( iWepEnt2 == -1 )
					bWep3 = true;

				int iWepEnt3 = GetPlayerWeaponSlot(iClient, TFWeaponSlot_Primary),
				iWepIndex = GetEntProp( iWepEnt, Prop_Send, "m_iItemDefinitionIndex" ),
				iWepIndex2 = 1;
				if ( !bWep3 )
					iWepIndex2 = GetEntProp( iWepEnt2, Prop_Send, "m_iItemDefinitionIndex" );
				else
					iWepIndex2 = 0;

				int iWepIndex3 = GetEntProp( iWepEnt3, Prop_Send, "m_iItemDefinitionIndex" ),
				iSize = g_hRestrictedWeps.Size;

				char sKey[ 4 ], iAuxIndex;
				for ( int i = 1; i <= iSize; i++ ) {
					IntToString( i, sKey, sizeof( sKey ) );
					if ( g_hRestrictedWeps.GetValue( sKey, iAuxIndex ) ) {
						if ( iWepIndex == iAuxIndex )
							bReplaceWep = true;
						if ( iWepIndex2 == iAuxIndex )
							bReplaceWep2 = true;
						if ( iWepIndex3 == iAuxIndex )
							bReplaceWep3 = true;
					}
				}
			}

			if ( bReplaceWep ) {
				TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Melee );

				int iWeaponToUse = -1;
				if ( g_bUseAllClass ) {
					int iAcwSize = g_hAllClassWeps.Size, iRndNum;
					if ( g_bUseDefault )
						iRndNum = GetRandomInt( 1, iAcwSize + 1 );
					else
						iRndNum = GetRandomInt( 1, iAcwSize );

					if ( iRndNum <= iAcwSize ) {
						char sKey[ 4 ];
						IntToString( iRndNum, sKey, sizeof( sKey ) );
						g_hAllClassWeps.GetValue( sKey, iWeaponToUse );
					}
				}

				//Here we give a melee to every class
				switch ( iClass ) {
					case TFClass_Scout: {
						hItem.SetClassname( "tf_weapon_bat" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 190;
					}
					case TFClass_Sniper: {
						hItem.SetClassname( "tf_weapon_club" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 193;
					}
					case TFClass_Soldier: {
						hItem.SetClassname( "tf_weapon_shovel" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 196;
					}
					case TFClass_DemoMan: {
						hItem.SetClassname( "tf_weapon_bottle" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 191;
					}
					case TFClass_Medic: {
						hItem.SetClassname( "tf_weapon_bonesaw" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 198;
					}
					case TFClass_Heavy: {
						hItem.SetClassname( "tf_weapon_fists" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 195;
					}
					case TFClass_Pyro: {
						hItem.SetClassname( "tf_weapon_fireaxe" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 192;
					}
					case TFClass_Spy: {
						hItem.SetClassname( "tf_weapon_knife" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 194;
					}
					case TFClass_Engineer: {
						hItem.SetClassname( "tf_weapon_wrench" );
						if ( iWeaponToUse == -1 )
							iWeaponToUse = 197;
					}
				}

				hItem.ItemIndex = iWeaponToUse;
				EquipPlayerWeapon( iClient, hItem.GiveNamedItem( iClient ) );
			}

			if ( bReplaceWep2 ) {
				TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Secondary );

				int iWeaponToUse = -1;

				//Here we give a secondary to every class
				switch ( iClass ) {
					case TFClass_Scout: {
						hItem.SetClassname( "tf_weapon_pistol" );
						iWeaponToUse = 22;
					}
					case TFClass_Sniper: {
						hItem.SetClassname( "tf_weapon_smg" );
						iWeaponToUse = 16;
					}
					case TFClass_Soldier: {
						hItem.SetClassname( "tf_weapon_shotgun_soldier" );
						iWeaponToUse = 10;
					}
					case TFClass_DemoMan: {
						hItem.SetClassname( "tf_weapon_pipebomblauncher" );
						iWeaponToUse = 20;
					}
					case TFClass_Medic: {
						hItem.SetClassname( "tf_weapon_medigun" );
						iWeaponToUse = 29;
					}
					case TFClass_Heavy: {
						hItem.SetClassname( "tf_weapon_shotgun_hwg" );
						iWeaponToUse = 11;
					}
					case TFClass_Pyro: {
						hItem.SetClassname( "tf_weapon_shotgun_pyro" );
						iWeaponToUse = 12;
					}
					case TFClass_Spy: {
						hItem.SetClassname( "tf_weapon_revolver" );
						iWeaponToUse = 24;
					}
					case TFClass_Engineer: {
						hItem.SetClassname( "tf_weapon_pistol" );
						iWeaponToUse = 22;
					}
				}

				hItem.ItemIndex = iWeaponToUse;
				EquipPlayerWeapon( iClient, hItem.GiveNamedItem( iClient ) );
			}

			if ( bReplaceWep3 ) {
				TF2_RemoveWeaponSlot( iClient, TFWeaponSlot_Primary );

				int iWeaponToUse = -1;

				//Here we give a primary to every class
				switch ( iClass ) {
					case TFClass_Scout: {
						hItem.SetClassname( "tf_weapon_scattergun" );
						iWeaponToUse = 13;
					}
					case TFClass_Sniper: {
						hItem.SetClassname( "tf_weapon_sniperrifle" );
						iWeaponToUse = 14;
					}
					case TFClass_Soldier: {
						hItem.SetClassname( "tf_weapon_rocketlauncher" );
						iWeaponToUse = 18;
					}
					case TFClass_DemoMan: {
						hItem.SetClassname( "tf_weapon_grenadelauncher" );
						iWeaponToUse = 19;
					}
					case TFClass_Medic: {
						hItem.SetClassname( "tf_weapon_syringegun_medic" );
						iWeaponToUse = 17;
					}
					case TFClass_Heavy: {
						hItem.SetClassname( "tf_weapon_minigun" );
						iWeaponToUse = 15;
					}
					case TFClass_Pyro: {
						hItem.SetClassname( "tf_weapon_flamethrower" );
						iWeaponToUse = 21;
					}
					case TFClass_Engineer: {
						hItem.SetClassname( "tf_weapon_shotgun_primary" );
						iWeaponToUse = 9;
					}
				}

				hItem.ItemIndex = iWeaponToUse;
				EquipPlayerWeapon( iClient, hItem.GiveNamedItem( iClient ) );
			}
		}

		TF2_SwitchToSlot( iClient, TFWeaponSlot_Primary );

		//disable medic guns heal
		if ( g_bDisableMedicGunHeal && iClass == TFClass_Medic ) {
			TF2Attrib_SetByName( iClient, "heal rate penalty", 0.0 );
			TF2Attrib_SetByName( iClient, "ubercharge rate penalty", 0.0 );
		}

		if ( g_bDisableLunchHeal && iClass == TFClass_Heavy )
			TF2Attrib_SetByName( iClient, "lunchbox healing decreased", 0.0 );

		if ( g_bDisableSpyCloak )
			TF2Attrib_SetByName( iClient, "mod_disguise_consumes_cloak", 1.0 );
	}

	hItem.Close();
}

/* OnPlayerSpawn()
**
** Here we enable the glow (if we need to), we set the spy cloak and we move the death player.
** -------------------------------------------------------------------------- */
public void OnPlayerSpawn(Event event, const char[] name, bool dontBroadcast) {
	if ( !g_bIsDRmap )
		return;

	int iClient = GetClientOfUserId( event.GetInt( "userid" ) );
	if ( !iClient )
		return;

	if ( g_bDisableFallDamage )
		TF2Attrib_SetByName( iClient, "cancel falling damage", 1.0 );

	int iCond = GetEntProp( iClient, Prop_Send, "m_nPlayerCond" );
	if ( iCond & PLAYERCOND_SPYCLOAK )
		SetEntProp( iClient, Prop_Send, "m_nPlayerCond", iCond | ~PLAYERCOND_SPYCLOAK );

	if( GetClientTeam( iClient ) == TEAM_BLUE && iClient != g_iLastDeath ) {
		ChangeAliveClientTeam( iClient, TEAM_RED );
		CreateTimer( 0.2, RespawnRebalanced, GetClientUserId( iClient ) );
	}

	if ( g_bOnPreparation )
		SetEntityMoveType( iClient, MOVETYPE_NONE );
}

/* Disable Self Damage
**
** Here we disable damage by yourself
** -------------------------------------------------------------------------- */
public Action OnTakeDamage(int victim, int &attacker, int &inflictor, float &damage, int &damagetype, int &weapon, float damageForce[3], float damagePosition[3], int damagecustom) {
	return ( g_bDisableSelfDamage && victim == attacker ) ? Plugin_Handled : Plugin_Continue;
}

/* OnPlayerDeath()
**
** Here we reproduce sounds if needed and activate the glow effect if needed
** -------------------------------------------------------------------------- */
public Action OnPlayerDeath(Event event, const char[] name, bool dontBroadcast) {
	if ( !g_bIsDRmap || g_bOnPreparation )
		return;

	int iClient = GetClientOfUserId( event.GetInt( "userid" ) );
	if ( !iClient )
		return;

	int iAliveRunners = GetAlivePlayersCount( TEAM_RED, iClient );
	if ( GetClientTeam( iClient ) == TEAM_RED && iAliveRunners > 0 )
		EmitRandomSound( g_hSndOnDeath, iClient );

	if ( iAliveRunners == 1 )
		EmitRandomSound( g_hSndLastAlive, GetLastPlayer( TEAM_RED, iClient ) );

	int iCurrentDeath = GetLastPlayer( TEAM_BLUE );
	bool bValidDeath = IsInBounds( iCurrentDeath, 1, MaxClients ) && IsClientInGame( iCurrentDeath );
	if ( bValidDeath )
		event.SetInt( "attacker", GetClientUserId( iCurrentDeath ) );

	if ( g_bCanEmitSoundToDeath ) {
		if ( bValidDeath )
			EmitRandomSound( g_hSndOnKill, iCurrentDeath );
		g_bCanEmitSoundToDeath = false;
		CreateTimer( g_flOnKillDelay, ReenableDeathSound );
	}

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !( IsClientInGame( i ) && IsPlayerAlive( i ) ) )
			continue;

		switch ( GetClientTeam( i ) ) {
			case TEAM_RED: {
				if ( iAliveRunners == g_iRunnerOutline )
					SetEntProp( i, Prop_Send, "m_bGlowEnabled", true );
			}
			case TEAM_BLUE: {
				if ( iAliveRunners == g_iDeathOutline )
					SetEntProp( i, Prop_Send, "m_bGlowEnabled", true );
			}
		}
	}

	if ( !g_bMeleeOnly && bValidDeath ) {
		TF2Attrib_RemoveByName( iCurrentDeath, "max health additive bonus" );
		SetEntityHealth( iCurrentDeath, g_iDefaultHPBlue );

		bool bChangeHP = true;

		int iHP = GetClientHealth( g_iDefaultHPBlue );
		if ( iAliveRunners >= 20 && iAliveRunners < 30 )
			iHP = 1700 - iHP;
		else if ( iAliveRunners >= 15 && iAliveRunners < 20 )
			iHP = 1500 - iHP;
		else if ( iAliveRunners >= 10 && iAliveRunners < 15 )
			iHP = 1000 - iHP;
		else if ( iAliveRunners >= 5 && iAliveRunners < 10 )
			iHP = 700 - iHP;
		else if( iAliveRunners >= 2 && iAliveRunners < 5 )
			iHP = 500 - iHP;
		else if ( iAliveRunners == 1 )
			iHP = 200 - iHP;
		else
			bChangeHP = false;

		if ( bChangeHP ) {
			TF2Attrib_SetByName( iCurrentDeath, "max health additive bonus", float( iHP ) );
			SetEntityHealth( iCurrentDeath, iHP );
		}
	}
}


public Action ReenableDeathSound(Handle timer, any data) {
	g_bCanEmitSoundToDeath = true;
}


/* BalanceTeams()
**
** Moves players to their new team in this round.
** -------------------------------------------------------------------------- */
stock void BalanceTeams() {
	if ( !g_bIsDRmap )
		return;

	int iCount = GetClientCount( true );
	if ( iCount < 2 ) {
		CPrintToChatAll( CHAT_PREFIX ... "%t", "DR_NEED_MORE_PLAYERS" );
		return;
	}

	bool bDBD = iCount > 4;

	CPrintToChatAll( CHAT_PREFIX ... "%t", "DR_DBD_DISABLED" );

	int iMaxPoints = 1, iNewDeath = -1;
	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !IsClientInGame( i ) || ( bDBD && g_iDontBeDeath[ i ] >= DBD_ON ) )
			continue;

		if ( iMaxPoints < g_iQueuePriory[ i ] )
			iMaxPoints = g_iQueuePriory[ i ];
		if ( iMaxPoints == g_iQueuePriory[ i ] )
			iNewDeath = i;
	}

	if ( iNewDeath == -1 ) {
		CPrintToChatAll( CHAT_PREFIX ... "%t", "DR_INVALID_DEATH" );
		return;
	}

	g_iLastDeath = iNewDeath;
	int iTeam;
	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( !IsClientInGame( i ) )
			continue;

		iTeam = GetClientTeam( i );
		if ( iTeam < TEAM_RED )
			continue;

		if ( i == iNewDeath ) {
			if ( iTeam != TEAM_BLUE )
				ChangeAliveClientTeam( i, TEAM_BLUE );

			if ( TF2_GetPlayerClass( i ) == TFClass_Unknown )
				TF2_SetPlayerClass( i, TFClass_Scout, false, true );

			g_iQueuePriory[ i ] = 1;
		}
		else if ( iTeam != TEAM_RED )
			ChangeAliveClientTeam( i, TEAM_RED );

		CreateTimer( 0.2, RespawnRebalanced, GetClientUserId( i ) );
	}

	if ( !IsClientInGame( iNewDeath ) ) {
		CPrintToChatAll( CHAT_PREFIX ... "%t", "DR_ISN'T_INGAME" );
		return;
	}

	CPrintToChatAll( CHAT_PREFIX ... "%t", "DR_NEW_DEATH", iNewDeath );
	//g_timesplayed_asdeath[g_iLastDeath]++;
}

/* OnGameFrame()
**
** We set the player max speed on every frame, and also we set the spy's cloak, scout drink and charge demoshield on empty.
** -------------------------------------------------------------------------- */
public void OnGameFrame() {
	if ( !g_bIsDRmap )
		return;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( IsClientInGame( i ) && IsPlayerAlive( i ) ) {
			switch ( GetClientTeam( i ) ) {
				case TEAM_RED:	SetEntPropFloat( i, Prop_Send, "m_flMaxspeed", g_flRunnerSpeed );
				case TEAM_BLUE:	SetEntPropFloat( i, Prop_Send, "m_flMaxspeed", g_flDeathSpeed );
			}

			switch ( TF2_GetPlayerClass( i ) ) {
				case TFClass_Spy: {		// if you want disable spy cloack, set "DisableSpyCloack" "1" in deathrun.cfg
					if ( g_bDisableSpyCloak )
						SetCloak( i, 1.0 );
				}
				case TFClass_Scout: {	// if you want disable scout drink, set "DisableScoutDrink" "1" in deathrun.cfg
					if ( g_bDisableScoutDrink )
						SetDrink( i, 1.0 );
				}
				case TFClass_DemoMan: {	// if you want disable demo shield, set "DisableDemoShield" "1" in deathrun.cfg
					if ( g_bDisableDemoShield && !TF2_IsPlayerInCondition( i, TFCond_Charging ) )
						SetCharge( i, 1.0 );
				}
			}
		}
	}
}

/* TF2_SwitchToSlot()
**
** Changes the client's slot to the desired one.
** -------------------------------------------------------------------------- */
stock void TF2_SwitchToSlot(int client, int slot) {
	if ( slot >= 0 && slot <= 5 && IsClientInGame( client ) && IsPlayerAlive( client ) ) {
		char sClassName[ 64 ];
		int iWep = GetPlayerWeaponSlot( client, slot );
		if ( iWep > MaxClients && IsValidEdict( iWep ) && GetEdictClassname( iWep, sClassName, sizeof( sClassName ) ) ) {
			FakeClientCommandEx( client, "use %s", sClassName );
			SetEntPropEnt( client, Prop_Send, "m_hActiveWeapon", iWep );
		}
	}
}

/* SetCloak()
**
** Function used to set the spy's cloak meter.
** -------------------------------------------------------------------------- */
stock void SetCloak(int client, float value) {
	SetEntPropFloat( client, Prop_Send, "m_flCloakMeter", value );
}

stock void SetDrink(int client, float value) {
	SetEntPropFloat( client, Prop_Send, "m_flEnergyDrinkMeter", value );
}

stock void SetCharge(int client, float value) {
	SetEntPropFloat( client, Prop_Send, "m_flChargeMeter", value );
}

/* RespawnRebalanced()
**
** Timer used to spawn a client if he/she is in game and if it isn't alive.
** -------------------------------------------------------------------------- */
public Action RespawnRebalanced(Handle timer, any data) {
	int iClient = GetClientOfUserId( data );
	if ( iClient && !IsPlayerAlive( iClient ) )
		TF2_RespawnPlayer( iClient );
}

/* OnConfigsExecuted()
**
** Here we get the default values of the CVars that the plugin is going to modify.
** -------------------------------------------------------------------------- */
public void OnConfigsExecuted() {
	g_iQueueDef = CVAR_UseQueue.IntValue;
	g_iUnbalanceDef = CVAR_UnbalanceLimit.IntValue;
	g_iAutoBalanceDef = CVAR_AutoTeamBalance.IntValue;
	g_iFirstBloodDef = CVAR_FirstBlood.IntValue;
	g_iScrambleAutoDef = CVAR_ScrambleAuto.IntValue;
	g_iAirDashDef = CVAR_AirDash.IntValue;
	g_iPushDef = CVAR_Push.IntValue;
}

/* SetupCvars()
**
** Modify several values of the CVars that the plugin needs to work properly.
** -------------------------------------------------------------------------- */
void SetupCvars() {
	CVAR_UseQueue.IntValue = 0;
	CVAR_UnbalanceLimit.IntValue = 0;
	CVAR_AutoTeamBalance.IntValue = 0;
	CVAR_FirstBlood.IntValue = 0;
	CVAR_ScrambleAuto.IntValue = 0;
	CVAR_AirDash.IntValue = 0;
	CVAR_Push.IntValue = 0;
}

/* ResetCvars()
**
** Reset the values of the CVars that the plugin used to their default values.
** -------------------------------------------------------------------------- */
void ResetCvars() {
	CVAR_UseQueue.IntValue = g_iQueueDef;
	CVAR_UnbalanceLimit.IntValue = g_iUnbalanceDef;
	CVAR_AutoTeamBalance.IntValue = g_iAutoBalanceDef;
	CVAR_FirstBlood.IntValue = g_iFirstBloodDef;
	CVAR_ScrambleAuto.IntValue = g_iScrambleAutoDef;
	CVAR_AirDash.IntValue = g_iAirDashDef;
	CVAR_Push.IntValue = g_iPushDef;

	//We clear the tries
	//ProcessListeners(true);
	g_hRestrictedWeps.Clear();
	g_hAllClassWeps.Clear();
	g_hCmdList.Clear();
	// ClearTrie(g_CmdTeamToBlock);
	// ClearTrie(g_CmdBlockOnlyOnPrep);
	g_hSndRoundStart.Clear();
	g_hSndOnDeath.Clear();
	g_hSndOnKill.Clear();
	g_hSndLastAlive.Clear();
}

/* Command_Block()
**
** Blocks a command, check teams and if it's on preparation.
** --------------------------------------------------------------------------
public Action:Command_Block(client, const String:command[], argc)
{
	if(g_bIsDRmap)
	{
		new PreparationOnly, blockteam;
		GetTrieValue(g_CmdBlockOnlyOnPrep,command,PreparationOnly);
		//If the command must be blocked only on preparation
		//and we aren't on preparation time, we let the client run the command.
		if(!g_bOnPreparation && PreparationOnly == 1)
			return Plugin_Stop;

		GetTrieValue(g_CmdTeamToBlock,command,blockteam);
		//If the client has the same team as "g_CmdTeamToBlock"
		//or it's for both teams, we block the command.
		if(GetClientTeam(client) == blockteam  || blockteam == 1)
			return Plugin_Stop;

	}
	return Plugin_Continue;
}
*/

/* EmitRandomSound()
**
** Emits a random sound from a trie, it will be emitted for everyone is a client isn't passed.
** -------------------------------------------------------------------------- */
stock void EmitRandomSound(StringMap sndHash, int client = -1) {
	char sKey[ 4 ], sSndFile[ PLATFORM_MAX_PATH ];
	IntToString( GetRandomInt( 1, sndHash.Size ), sKey, sizeof( sKey ) );

	if ( sndHash.GetString( sKey, sSndFile, sizeof( sSndFile ) ) ) {
		if ( !sSndFile[ 0 ] )
			return;

		if ( client != -1 ) {
			if ( IsInBounds( client, 1, MaxClients ) && IsClientInGame( client ) && !IsFakeClient( client ) )
				EmitSoundToClient( client, sSndFile, _, _, SNDLEVEL_TRAIN );
			else
				return;
		}
		else
			EmitSoundToAll( sSndFile, _, _, SNDLEVEL_TRAIN );
	}
}

stock int GetAlivePlayersCount(int team, int ignore = -1) {
	int iCount = 0;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( IsClientInGame( i ) && GetClientTeam( i ) == team && IsPlayerAlive( i ) && i != ignore )
			iCount++;
	}

	return iCount;
}

stock int GetLastPlayer(int team, int ignore = -1) {
	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( IsClientInGame( i ) && GetClientTeam( i ) == team && IsPlayerAlive( i ) && i != ignore )
			return i;
	}

	return -1;
}

stock void ChangeAliveClientTeam(int client, int newTeam) {
	int oldTeam = GetClientTeam( client );

	if ( oldTeam != newTeam ) {
		SetEntProp( client, Prop_Send, "m_lifeState", 2 );
		ChangeClientTeam( client, newTeam );
		SetEntProp( client, Prop_Send, "m_lifeState", 0 );
		TF2_RespawnPlayer( client );
	}
}

stock bool IsInBounds(any value, any min, any max) {
	return ( value >= min && value <= max );
}

/* DisableBuilds
**
** Disable engineer buidls.
** -------------------------------------------------------------------------- */
public Action CommandListener_Build(int client, const char[] command, int argc) {
	if ( !g_bDisableAllBuildings ) {
		char sObjectType[ 2 ];
		GetCmdArg( 1, sObjectType, sizeof( sObjectType ) );

		switch ( StringToInt( sObjectType ) ) {
			case TFObject_Dispenser: {
				if ( g_bDisableDispenser )
					return Plugin_Handled;
			}
			case TFObject_Sentry: {
				if ( g_bDisableSentry )
					return Plugin_Handled;
			}
			case TFObject_Teleporter: {
				char sObjectMode[ 2 ];
				GetCmdArg( 2, sObjectMode, sizeof( sObjectMode ) );
				TFObjectMode objectMode = view_as<TFObjectMode>( StringToInt( sObjectMode ) );

				if ( ( objectMode == TFObjectMode_Entrance && g_bDisableTeleportEntr ) ||
					( objectMode == TFObjectMode_Exit && g_bDisableTeleportExit ) )
					return Plugin_Handled;
			}
		}
	}

	return Plugin_Continue;
}

/* OnDeathChangeTeam
**
** When death chage team we change death.
** -------------------------------------------------------------------------- */
public void OnDeathChangeTeam(Event event, const char[] name, bool dontBroadcast) {
	if ( !g_bIsDRmap )
		return;

	int iClient = GetClientOfUserId( event.GetInt( "userid" ) );
	if ( !iClient )
		return;

	TF2Attrib_RemoveByName( iClient, "max health additive bonus" );

	int iTeam = event.GetInt( "team" );
	if ( g_bOnPreparation ) {
		if ( iClient == g_iLastDeath && ( iTeam == TEAM_RED || iTeam == TEAM_SPECTATOR ) )
			BalanceTeams();
	}
}

/* OnDeathChangeTeam
**
** Add "points" on red team when round end.
** -------------------------------------------------------------------------- */
public void OnRoundEnd(Event event, const char[] name, bool dontBroadcast) {
	if ( event.GetInt( "team" ) != TEAM_RED )
		return;

	for ( int i = 1; i <= MaxClients; i++ ) {
		if ( IsClientInGame( i ) && GetClientTeam( i ) == TEAM_RED ) {
			g_iQueuePriory[ i ] += 10;
			if ( IsPlayerAlive( i ) )
				g_iQueuePriory[ i ] += 10;
		}
	}
}